<template>
  <div class="app-container">
    <!-- 搜索栏 -->
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch">
      <el-form-item label="学员" prop="successorId" v-if="isMentor">
        <el-select
          @change="handleQuery"
          size="small"
          v-model="queryParams.successorId"
          placeholder="请选择学员"
          style="width:200px"
        >
          <el-option
            v-for="successor in this.successorOptions"
            :key="successor.key"
            :label="successor.value"
            :value="successor.key"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="年" prop="feedbackYear">
        <el-date-picker
          @change="handleQuery"
          v-model="queryParams.feedbackYearTemp"
          placeholder="请选择年"
          clearable
          type="year"
          size="small"
          @input="handleQuery"
          style="width:200px"
        />
      </el-form-item>
      <!--<el-form-item>-->
        <!--<el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>-->
      <!--</el-form-item>-->
    </el-form>
    <!-- 标签页 -->
    <el-tabs type="border-card" @tab-click="handleTabClick" v-model="activeMonth">
      <el-tab-pane
        :key="item.key"
        v-for="(item) in monthTabs"
        :label="item.value"
        :name="item.key"
        :lazy="true"
      >
        <div v-if="item.key == activeMonth">
          <!-- 培养计划总表 -->
          <el-table
            v-loading="loading"
            :data="dataList"
            @selection-change="handleSelectionChange"
            ref="feedbackListSeasonalTable"
            border
            :cell-style="tableCellStyle"
          >
            <template slot="empty">
              <el-empty :image-size="100" description='当月无学习计划'></el-empty>
            </template>
            <el-table-column label="培养内容" align="center" prop="plantName" width="600px"/>
            <el-table-column label="开始日期" align="center" prop="startDate"/>
            <el-table-column label="结束日期" align="center" prop="endDate"/>
            <el-table-column label="实际完成日期" align="center" prop="dateOfCompletion"/>
            <el-table-column label="学习状态" align="center" prop="studyState" :formatter="studyStateFormat"/>
            <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
              <template slot-scope="scope">
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-chat-dot-round"
                  v-hasPermi="['spec:plan:edit']"
                  @click="handleFeedback(scope.row)"
                >详情</el-button>
              </template>
            </el-table-column>
          </el-table>
          <!-- 导师反馈 -->
          <div>
            <h3>导师反馈</h3>
            <editor
              v-if="isMentor"
              :min-height="300"
              v-model="mentorFeedback"
            />
            <span
              v-if="!isMentor"
              v-html="mentorFeedback"
              style="overflow:scroll; display:block; border:1px solid #CCCCCC; height: 300px; padding:15px;font-family: Helvetica, Arial, sans-serif; font-size: 13px;"
            >
            </span>
          </div>
          <!-- 保存按钮 -->
          <div style="text-align:center;margin: 20px auto;">
            <el-button
              v-if="isMentor"
              size="medium"
              type="success"
              @click="handleSave"
            >
              保存
            </el-button>
          </div>
        </div>
      </el-tab-pane>
    </el-tabs>
    <!-- 详情对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="feedbackDialog.title" :visible.sync="feedbackDialog.open" width="800px" append-to-body>
      <div style="width:700px; margin:0px auto;">
        <h3 style="margin-bottom:20px;">学员心得</h3>
        <el-table :data="tableData" border style="width: 100%">
          <el-table-column prop="id" label="编号" width="50"></el-table-column>
          <el-table-column prop="question" label="问题" width="250"></el-table-column>
          <el-table-column prop="answer" label="答案"></el-table-column>
        </el-table>
        <el-table :data="docFeedback.commonfileList" border>
          <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              <a  class="link-type"  @click="handleDownload(scope.row)">
                <span>{{ scope.row.fileName }}</span>
              </a>
            </template>
          </el-table-column>
          <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true" width="80" />
          <el-table-column :label="$t('上传人')" align="center" prop="creator" :show-overflow-tooltip="true" width="120"/>
          <el-table-column :label="$t('操作')" align="center" width="120" class-name="small-padding fixed-width">
            <template slot-scope="scope">
               <el-button
              v-if="scope.row.fileName.endsWith('pdf')||scope.row.fileName.endsWith('xlsx')||scope.row.fileName.endsWith('md')
                 ||scope.row.fileName.endsWith('docx')||scope.row.fileName.endsWith('doc')||scope.row.fileName.endsWith('txt')
                 ||scope.row.fileName.endsWith('jpg')||scope.row.fileName.endsWith('png')||scope.row.fileName.endsWith('csv')
                 ||scope.row.fileName.endsWith('mp4')||scope.row.fileName.endsWith('svg')||scope.row.fileName.endsWith('dwg')
                 ||scope.row.fileName.endsWith('flv')||scope.row.fileName.endsWith('swf')||scope.row.fileName.endsWith('gif')
                 ||scope.row.fileName.endsWith('3gp')||scope.row.fileName.endsWith('mkv')||scope.row.fileName.endsWith('tif')"
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSee(scope.row)"
            > {{ $t('预览') }}</el-button>
            <el-button
              v-if="scope.row.fileName.endsWith('ppt')||scope.row.fileName.endsWith('pptx') "
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSeePPT(scope.row)"
            > {{ $t('ppt预览') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-download"
              @click="handleDownload(scope.row)"
            >{{ $t('下载') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteDoc(scope.row)"
            >{{ $t('删除') }}</el-button>
            </template>
          </el-table-column>
        </el-table>
        <el-form v-if="detailFeedback != null">
          <h3 style="margin-top:30px;margin-bottom:20px;">导师反馈</h3>
          <el-form-item>
            <p v-html="detailFeedback" style="border:1px solid #DFE6EC; overflow:scroll; height:200px;"/>
          </el-form-item>
        </el-form>
      </div>
    </el-dialog>
    <!-- 预览对话框 -->
        <el-dialog  :close-on-click-modal="false"  v-loading="loadingFlash"     element-loading-background="rgba(0,0,0,0.2)"                 v-dialogDrag :title="pdf.title" :visible.sync="pdf.open"  width="1300px" :center="true" append-to-body>
      <div style="margin-top: -60px;float: right;margin-right: 40px;">
        <el-button size="mini" type="text" @click="openPdf">{{$t('新页面打开PDF')}}</el-button></div>
      <div style="margin-top: -30px" >
        <iframe id="iFrame" class="iframe-html" :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px" v-if="ppt"></iframe>
      </div>
      <div style="padding: 30px; width: 100%; height: 100%;" >
        <el-carousel class="" ref="carousel"  arrow="always"  v-if="pptView"
                   height="700px"  trigger="click" :autoplay="false" indicator-position="outside">
          <el-carousel-item class="lun_img" v-for="item in imgs" v-bind:key="item" >
            <img :src="item" width="100%" height="100%" object-fit="cover" />
          </el-carousel-item>
        </el-carousel>

      </div>
    </el-dialog>
  </div>
</template>

<script>
import { getAnswer, addAnswer, updateAnswer, listAnswer } from "@/api/training/spec/answer";
import { allFileList, delCommonfile } from "@/api/common/commonfile";
import { addFeedback, getFeedbackByParams, listInvitedSuccessor, updateFeedback, listFeedback, getFeedbackByPlanId } from "@/api/training/spec/feedback";
import { listMentors } from "@/api/training/spec/successor";
import { listSuccessorsByMentorId, listPlanMonthly } from "@/api/training/spec/plan";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import Editor from '@/components/Editor';
import { getStaffId, isMentor } from "@/api/plant/staffmgr";

export default {
  name: "MonthlyFeedback",
  components: { Treeselect, Editor },
  data() {
    return {
      //图片集合   打开关闭按钮 等等
      imgs:[],
      jpgList:[],
      ppt:false,
      pptView:false,
      loadingFlash:false,
      // 当前用户id
      staffId: null,
      // 是否为导师
      isMentor: null,
      // 首选标签页
      activeMonth: null,
      // 月份标签页
      monthTabs: [
        { key: "1", value: "1月" },
        { key: "2", value: "2月" },
        { key: "3", value: "3月" },
        { key: "4", value: "4月" },
        { key: "5", value: "5月" },
        { key: "6", value: "6月" },
        { key: "7", value: "7月" },
        { key: "8", value: "8月" },
        { key: "9", value: "9月" },
        { key: "10", value: "10月" },
        { key: "11", value: "11月" },
        { key: "12", value: "12月" }
      ],
      // 导师标签
      mentorTabs: [],
      // 详情对话框表格数据
      tableData: [],
      // 反馈id
      feedbackId: null,
      // 父级反馈id
      parentId: null,
      // 会议日期快捷选项
      pickerOptions: {
        shortcuts: [{
          text: '今天',
          onClick(picker) {
            picker.$emit('pick', new Date());
          }
        }, {
          text: '昨天',
          onClick(picker) {
            const date = new Date();
            date.setTime(date.getTime() - 3600 * 1000 * 24);
            picker.$emit('pick', date);
          }
        }, {
          text: '一周前',
          onClick(picker) {
            const date = new Date();
            date.setTime(date.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', date);
          }
        }, {
          text: '一周后',
          onClick(picker) {
            const date = new Date();
            date.setTime(date.getTime() + 3600 * 1000 * 24 * 7);
            picker.$emit('pick', date);
          }
        }]
      },
      // 会议日期
      meetingDate: null,
      // 学习状态字典
      studyStateOptions: [],
      // 汇报展示附件参数
      doc: {  // 反馈附件
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'docSeasonal'
        },
        pType: 'docSeasonal',
        pId: null
      },
      // 培养计划总表数据
      dataList: [],
      // 首选标签页
      activeName: null,
      // 学员下拉列表
      successorOptions: [],
      // 导师下拉列表
      mentorOptions: [],
      // 导师数组
      mentorOptionsArray: [],
      // 包含导师id的查询对象
      queryObject: {
        mentorStaffId: ""
      },
      // 导师反馈内容
      mentorFeedback: "", // 季度反馈内容
      detailFeedback: "", // 计划详情反馈内容
      // 反馈对话框参数
      feedbackDialog: {
        id: 0,
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: ""
      },
      // 问卷单选框
      radio1: '',
      radio2: '',
      radio3: '',
      radio4: '',
      radio5: '',
      radio6: '',
      radio7: '',
      radio8: '',
      radio9: '',
      radio10: '',
      radio11: '',
      radio12: '',
      radio13: '',
      radio14: '',
      // 报告附件参数
      doc: {  // 季度汇报附件
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'plan'
        },
        pType: 'plan',
        pId: null
      },
      docFeedback: {  // 反馈附件
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'docFeedback'
        },
        pType: 'docFeedback',
        pId: null
      },
      // 标签页选中项
      activeName: 'zhu',
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专项培训反馈表格数据
      feedbackList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/spec/feedback/importData"
        },
          pdf : {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 100,
        feedbackType: null,
        mentorId: null,
        successorId: null,
        successorName: null,
        parentId: null,
        planId: null,
        feedbackYear: null,
        feedbackYearTemp: null,
        feedbackSeason: null,
        feedbackMonth: null,
        successorFeedback: null,
        mentorFeedback: null,
        feedbackScore: null,
        feedbackStatus: null,
        meetingDate: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  watch: {
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight -250
    })
    // 获取学习状态字典
    this.getDicts("st_study_state").then(response => {
      this.studyStateOptions = response.data;
    });
    // 初始化页面数据
    this.initPageData();
  },
  methods: {
    /** 标签页切换事件 */
    handleTabClick(tab) {
      this.queryParams.feedbackMonth = tab.name;
      this.getList();
      // 清空导师反馈内容
      this.mentorFeedback = "";
      // 根据月获取反馈id
      getFeedbackByParams({
        successorId: this.queryParams.successorId,
        feedbackYear: this.queryParams.feedbackYear,
        feedbackMonth: this.queryParams.feedbackMonth,
      }).then(response => {
        let data = response.data;
        // 设置反馈id为当前月反馈id
        this.feedbackId = data.id;
        // 刷新导师反馈内容
        this.mentorFeedback = data.mentorFeedback;
      });
    },
    /** 初始化页面数据 */
    initPageData() {
      // 获取当前日期
      let date = new Date();
      // 搜索条件默认为当年、当月
      this.queryParams.feedbackYear = date.getFullYear().toString();
      this.queryParams.feedbackYearTemp = date.getFullYear().toString();
      this.queryParams.feedbackMonth = ( date.getMonth() + 1 ).toString();
      this.activeMonth = ( date.getMonth() + 1 ).toString();
      // 获取当前用户id
      getStaffId().then(response => {
        this.staffId = response.data;
        // 判断当前用户是否为导师
        return isMentor();
      })
      .then(response => {
        this.isMentor = response.data;
        if (this.isMentor) {  // 当前用户是导师
          // 获取当前导师的学员列表
          listSuccessorsByMentorId(this.queryObject).then(response => {
            let data = response.data;
            for (let i = 0; i < data.length; i++) {
              if (i == 0 && data.length != 0) {
                // 默认选中列表中第一个学员
                this.queryParams.successorId = data[i].staffId;
                // 设置导师id
                this.queryParams.mentorId = this.staffId;
                // 查询学习计划列表
                this.getList();
              }
              this.successorOptions.push( { key: data[i].staffId, value: data[i].staffName } );
            }
            if (data.length != 0) {
              // 获取当前学员当年当月反馈id
              getFeedbackByParams({
                successorId: this.queryParams.successorId,
                feedbackYear: this.queryParams.feedbackYear,
                feedbackMonth: this.queryParams.feedbackMonth
              }).then(response => {
                let data = response.data;
                this.feedbackId = data.id;
                this.mentorFeedback = data.mentorFeedback;
              });
            }else {
              this.loading = false;
              return;
            }
          });
        } else {  // 当前用户是学员
          // 学员id = 当当前用户id
          this.queryParams.successorId = this.staffId;
          // 查询学习计划列表
          this.getList();
          // 获取当前学员当年当月反馈id
          getFeedbackByParams({
            successorId: this.queryParams.successorId,
            feedbackYear: this.queryParams.feedbackYear,
            feedbackMonth: this.queryParams.feedbackMonth
          }).then(response => {
            let data = response.data;
            this.feedbackId = data.id;
            this.mentorFeedback = data.mentorFeedback;
          });
        }
      });
    },
    /** 保存导师反馈内容 */
    saveMentorFeedback() {
      let feedback = {};
      feedback.id = this.feedbackId;
      feedback.mentorFeedback = this.mentorFeedback;
      updateFeedback(feedback);
    },
    /** 保存按钮处理 */
    handleSave() {
      // 保存导师反馈内容
      this.saveMentorFeedback();
      this.msgSuccess("保存成功");
    },
    /** 培养计划详情处理 */
    handleFeedback(row) {
      // 加载反馈附件
      this.docFeedback.id = row.id;
      this.docFeedback.queryParams.pId = row.id
      this.docFeedback.pId = row.id
      this.getFileListFeedback();
      // 清空导师反馈内容
      this.detailFeedback = null;
      // 清空表格数据
      this.tableData = [];
      let feedback1 = {};
      feedback1.planId = row.id;
      feedback1.questionId = 1;
      let feedback2 = {};
      feedback2.planId = row.id;
      feedback2.questionId = 2;
      let feedback3 = {};
      feedback3.planId = row.id;
      feedback3.questionId = 3;
      let answerObj1 = {};
      let answerObj2 = {};
      let answerObj3 = {};
      // 获取问题和答案
      getAnswer(feedback1).then(response => {
        let data = response.data;
        if (data != null) {
          answerObj1 = { id: 1, question: data.question, answer: data.answer};
        }
        return getAnswer(feedback2);
      }).then(response => {
        let data = response.data;
        if (data != null) {
          answerObj2 = { id: 2, question: data.question, answer: data.answer};
        }
        return getAnswer(feedback3);
      }).then(response => {
        let data = response.data;
        if (data != null) {
          answerObj3 = { id: 3, question: data.question, answer: data.answer};
          this.tableData.push(answerObj1);
          this.tableData.push(answerObj2);
          this.tableData.push(answerObj3);
        }
        // 获取导师反馈内容
        return getFeedbackByPlanId(row.id);
      }).then(response => {
        if (response.data != null) {
          let data = response.data;
          this.detailFeedback = data.mentorFeedback;
        }
        this.feedbackDialog.title = row.staffName + row.plantName + "学习情况详情";
        this.feedbackDialog.planId = row.id;
        this.feedbackDialog.studyState = row.studyState;
        this.feedbackDialog.open = true;
      });
    },
    /** 单元格样式 */
    tableCellStyle(row, column, rowIndex, columnIndex) {
      if (row.column.label === "实际完成日期" && row.row.dateOfCompletion > row.row.endDate) {
        return "background: #FFEEEE"
      }
    },
    /** 学习状态字典翻译 */
    studyStateFormat(row, column) {
      return this.selectDictLabel(this.studyStateOptions, row.studyState);
    },
    /** 文件下载处理 */
    handleDownload(row) {
      var name = row.fileName;
      var url = row.fileUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a');
      a.setAttribute('download', name);
      a.setAttribute('target', '_blank');
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url);
      a.click();
    },

    /** 汇报附件参数初始化 */
    initFileList(id) {
      this.doc.queryParams.pId = id
      this.doc.pId = id
      this.getFileList()
      // this.$nextTick(() => {
      //   this.$refs.doc.clearFiles()
      // })
    },
    getFileList() {
      allFileList(this.doc.queryParams).then(response => {
        this.doc.commonfileList = response;
      });
    },
    getFileListFeedback() {
      allFileList(this.docFeedback.queryParams).then(response => {
        this.docFeedback.commonfileList = response;
      });
    },
    /** 附件上传中处理 */
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
      this.doc.isUploading = true;
    },
    handleFileDocProgressFeedback(event, file, fileList) {
      this.docFeedback.file = file;
      this.docFeedback.isUploading = true;
    },
    /** 附件上传成功处理 */
    handleFileDocSuccess(response, file, fileList) {
      this.doc.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      this.getFileList()
    },
    handleFileDocSuccessFeedback(response, file, fileList) {
      this.docMentorFeedback.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      this.getFileListFeedback()
    },
    /** 删除按钮操作 */
    handleDeleteDoc(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileList()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    /** 查询专项培训反馈列表 */
    getList() {
      this.loading = true;
      listPlanMonthly(this.queryParams).then(response => {
        this.dataList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        feedbackType: null,
        mentorId: null,
        successorId: null,
        successorName: null,
        parentId: null,
        planId: null,
        feedbackYear: null,
        feedbackSeason: null,
        feedbackMonth: null,
        successorFeedback: null,
        mentorFeedback: null,
        feedbackScore: null,
        feedbackStatus: 0,
        meetingDate: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (typeof(this.queryParams.feedbackYearTemp) == 'string') {
        this.queryParams.feedbackYear = this.queryParams.feedbackYearTemp;
      } else {
        this.queryParams.feedbackYear = this.queryParams.feedbackYearTemp.getFullYear();
      }
      this.queryParams.pageNum = 1;
      this.getList();
      // 清空导师反馈内容
      this.mentorFeedback = "";
      getFeedbackByParams({
        successorId: this.queryParams.successorId,
        feedbackYear: this.queryParams.feedbackYear,
        feedbackMonth: this.queryParams.feedbackMonth,
      }).then(response => {
        let data = response.data;
        this.feedbackId = data.id;
        this.mentorFeedback = data.mentorFeedback;
      });
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    //文件预览
    openPdf(){
      //ppt就跳路由预览，office就直接打开文件新页面
      const didi={ imgs:this.imgs}
      if( this.pptView==true&&this.ppt==false){
        let routeUrl = this.$router.resolve({
          path: "/cpms/index.html#/pptyulan",
          query:didi
        });
        window.open("/cpms/index.html#/pptyulan?id=" + this.pdf.pdfUrl, '_blank')
        console.log(this.imgs)
      }else {
        window.open(this.pdf.pdfUrl)
      }
    },
    handleSeePPT (row){
      //ppt预览
      this.loadingFlash=true
      this.pdf.open =true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = row.fileUrl
      this.pptView=true
      this.ppt=false
      const formatDate =new FormData();
      formatDate.append("filepath",row.fileUrl)

      //调用文件预览api
      let res= this.officeConvert.pptConvertCommon(formatDate)

      //查看接受的全局方法的返回结果 console.log(res)
      //利用.then方法接受Promise对象

      res.then((result)=>{
        //关闭加载中
        this.loadingFlash=false

        //成功时直接给地址
        this.videoList = result.data.imagePathList
        //将返回的地址集合遍历添加到绑定的数组中
        this.imgs=[]
        for (var key=0;key<this.videoList.length;key++) {
          this.imgs.push( process.env.VUE_APP_BASE_API+  this.videoList[key]  );
        }
      }).catch(result => {

        //请求失败，关闭loading，pdf地址直接为为空，不显示
        this.pdf.pdfUrl =""
        this.loadingFlash = false;
      })
    },
    handleSee (row){
      //office预览
      this.loadingFlash=true
      this.pdf.open =true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl =""

      this.pptView=false
      this.ppt=true
   //如果是PDF等直接可以打开的就不调接口，否则调用接口
      if(row.fileName.endsWith('pdf')){
             this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
              this.loadingFlash=false
      }
      else{
      const formatDate =new FormData();
      formatDate.append("filepath",row.fileUrl)

      //调用文件预览api
      let res= this.officeConvert.officeConvertCommon(formatDate)


      //查看接受的全局方法的返回结果 console.log(res)
      //利用.then方法接受Promise对象
      res.then((result)=>{
        //关闭加载中
        this.loadingFlash=false

        if(result.msg.includes("csv")){
          this.pdf.pdfUrl =process.env.VUE_APP_BASE_API+ result.data
          this.$alert(result.msg, this.$t('检查乱码'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });

        }else if(result.msg.includes("不存在")){
          //文件不存在时提示
          this.pdf.pdfUrl =""
          this.$alert(result.msg, this.$t('预览失败'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
          this.pdf.open =false
        }else if(result.msg.includes("不支持此格式")){

          this.pdf.pdfUrl =""
          this.$alert(result.msg, this.$t('预览失败'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
          this.pdf.open =false
        } else{
          //成功时直接给地址
          this.pdf.pdfUrl =process.env.VUE_APP_BASE_API+ result.data
        }
        // this.$nextTick(() => {
        //   const iframe = window.frames['iFrame']
        //   const handleLoad = () => {
        //     setTimeout(() => {
        //       const Do = (iframe.contentWindow || iframe.contentDocument)
        //       console.log(Do.document.getElementsByTagName('table')[0])
        //       Do.document.getElementsByTagName('table')[0].style.width = "100%"
        //       Do.document.getElementsByTagName('table')[0].setAttribute("class","table")
        //     }, 500)
        //   }
        //   iframe.addEventListener('load', handleLoad, true)
        // })
      }).catch(result => {

        //请求失败，关闭loading，pdf地址直接为为空，不显示
        this.pdf.pdfUrl =""
        this.loadingFlash = false;

      })
        }


    },
  }
};
</script>

<style scoped>
  .question{
    margin: 20px 0px;
    padding-left: 20px;
  }
  .answer{
    padding-bottom: 10px;
    padding-left: 40px;
  }
  h3{
    margin: 20px 0px;
  }
</style>
